<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AbstractFinancialDocumentHolder StructType
 * @subpackage Structs
 */
abstract class AbstractFinancialDocumentHolder extends PWFinanceObject
{
    /**
     * The documents
     * Meta information extracted from the WSDL
     * - arrayType: tns1:Document[]
     * - base: soapenc:Array
     * - nillable: true
     * - ref: soapenc:arrayType
     * @var \StructType\Document[]
     */
    public $documents;
    /**
     * Constructor method for AbstractFinancialDocumentHolder
     * @uses AbstractFinancialDocumentHolder::setDocuments()
     * @param \StructType\Document[] $documents
     */
    public function __construct(array $documents = array())
    {
        $this
            ->setDocuments($documents);
    }
    /**
     * Get documents value
     * @return \StructType\Document[]|null
     */
    public function getDocuments()
    {
        return $this->documents;
    }
    /**
     * This method is responsible for validating the values passed to the setDocuments method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDocuments method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDocumentsForArrayConstraintsFromSetDocuments(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $abstractFinancialDocumentHolderDocumentsItem) {
            // validation for constraint: itemType
            if (!$abstractFinancialDocumentHolderDocumentsItem instanceof \StructType\Document) {
                $invalidValues[] = is_object($abstractFinancialDocumentHolderDocumentsItem) ? get_class($abstractFinancialDocumentHolderDocumentsItem) : sprintf('%s(%s)', gettype($abstractFinancialDocumentHolderDocumentsItem), var_export($abstractFinancialDocumentHolderDocumentsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The documents property can only contain items of type \StructType\Document, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set documents value
     * @throws \InvalidArgumentException
     * @param \StructType\Document[] $documents
     * @return \StructType\AbstractFinancialDocumentHolder
     */
    public function setDocuments(array $documents = array())
    {
        // validation for constraint: array
        if ('' !== ($documentsArrayErrorMessage = self::validateDocumentsForArrayConstraintsFromSetDocuments($documents))) {
            throw new \InvalidArgumentException($documentsArrayErrorMessage, __LINE__);
        }
        $this->documents = $documents;
        return $this;
    }
    /**
     * Add item to documents value
     * @throws \InvalidArgumentException
     * @param \StructType\Document $item
     * @return \StructType\AbstractFinancialDocumentHolder
     */
    public function addToDocuments(\StructType\Document $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Document) {
            throw new \InvalidArgumentException(sprintf('The documents property can only contain items of type \StructType\Document, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->documents[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AbstractFinancialDocumentHolder
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
