<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Bill StructType
 * @subpackage Structs
 */
class Bill extends AbstractFinancialDocumentHolder
{
    /**
     * The billNumber
     * @var int
     */
    public $billNumber;
    /**
     * The billSplits
     * Meta information extracted from the WSDL
     * - arrayType: tns1:BillSplit[]
     * - base: soapenc:Array
     * - nillable: true
     * - ref: soapenc:arrayType
     * @var \StructType\BillSplit[]
     */
    public $billSplits;
    /**
     * The credit
     * @var bool
     */
    public $credit;
    /**
     * The dueDate
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $dueDate;
    /**
     * The markupAccountId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $markupAccountId;
    /**
     * The markupPercentage
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $markupPercentage;
    /**
     * The ownerDraw
     * @var bool
     */
    public $ownerDraw;
    /**
     * The paymentDate
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $paymentDate;
    /**
     * The refNo
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $refNo;
    /**
     * The tenantCharges
     * Meta information extracted from the WSDL
     * - arrayType: tns1:VMMLeaseCharge[]
     * - base: soapenc:Array
     * - nillable: true
     * - ref: soapenc:arrayType
     * @var \StructType\VMMLeaseCharge[]
     */
    public $tenantCharges;
    /**
     * The terms
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $terms;
    /**
     * The vendor
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $vendor;
    /**
     * The workOrderID
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $workOrderID;
    /**
     * Constructor method for Bill
     * @uses Bill::setBillNumber()
     * @uses Bill::setBillSplits()
     * @uses Bill::setCredit()
     * @uses Bill::setDueDate()
     * @uses Bill::setMarkupAccountId()
     * @uses Bill::setMarkupPercentage()
     * @uses Bill::setOwnerDraw()
     * @uses Bill::setPaymentDate()
     * @uses Bill::setRefNo()
     * @uses Bill::setTenantCharges()
     * @uses Bill::setTerms()
     * @uses Bill::setVendor()
     * @uses Bill::setWorkOrderID()
     * @param int $billNumber
     * @param \StructType\BillSplit[] $billSplits
     * @param bool $credit
     * @param string $dueDate
     * @param int $markupAccountId
     * @param float $markupPercentage
     * @param bool $ownerDraw
     * @param string $paymentDate
     * @param string $refNo
     * @param \StructType\VMMLeaseCharge[] $tenantCharges
     * @param string $terms
     * @param string $vendor
     * @param int $workOrderID
     */
    public function __construct($billNumber = null, array $billSplits = array(), $credit = null, $dueDate = null, $markupAccountId = null, $markupPercentage = null, $ownerDraw = null, $paymentDate = null, $refNo = null, array $tenantCharges = array(), $terms = null, $vendor = null, $workOrderID = null)
    {
        $this
            ->setBillNumber($billNumber)
            ->setBillSplits($billSplits)
            ->setCredit($credit)
            ->setDueDate($dueDate)
            ->setMarkupAccountId($markupAccountId)
            ->setMarkupPercentage($markupPercentage)
            ->setOwnerDraw($ownerDraw)
            ->setPaymentDate($paymentDate)
            ->setRefNo($refNo)
            ->setTenantCharges($tenantCharges)
            ->setTerms($terms)
            ->setVendor($vendor)
            ->setWorkOrderID($workOrderID);
    }
    /**
     * Get billNumber value
     * @return int|null
     */
    public function getBillNumber()
    {
        return $this->billNumber;
    }
    /**
     * Set billNumber value
     * @param int $billNumber
     * @return \StructType\Bill
     */
    public function setBillNumber($billNumber = null)
    {
        // validation for constraint: int
        if (!is_null($billNumber) && !(is_int($billNumber) || ctype_digit($billNumber))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($billNumber, true), gettype($billNumber)), __LINE__);
        }
        $this->billNumber = $billNumber;
        return $this;
    }
    /**
     * Get billSplits value
     * @return \StructType\BillSplit[]|null
     */
    public function getBillSplits()
    {
        return $this->billSplits;
    }
    /**
     * This method is responsible for validating the values passed to the setBillSplits method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBillSplits method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBillSplitsForArrayConstraintsFromSetBillSplits(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $billBillSplitsItem) {
            // validation for constraint: itemType
            if (!$billBillSplitsItem instanceof \StructType\BillSplit) {
                $invalidValues[] = is_object($billBillSplitsItem) ? get_class($billBillSplitsItem) : sprintf('%s(%s)', gettype($billBillSplitsItem), var_export($billBillSplitsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The billSplits property can only contain items of type \StructType\BillSplit, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set billSplits value
     * @throws \InvalidArgumentException
     * @param \StructType\BillSplit[] $billSplits
     * @return \StructType\Bill
     */
    public function setBillSplits(array $billSplits = array())
    {
        // validation for constraint: array
        if ('' !== ($billSplitsArrayErrorMessage = self::validateBillSplitsForArrayConstraintsFromSetBillSplits($billSplits))) {
            throw new \InvalidArgumentException($billSplitsArrayErrorMessage, __LINE__);
        }
        $this->billSplits = $billSplits;
        return $this;
    }
    /**
     * Add item to billSplits value
     * @throws \InvalidArgumentException
     * @param \StructType\BillSplit $item
     * @return \StructType\Bill
     */
    public function addToBillSplits(\StructType\BillSplit $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BillSplit) {
            throw new \InvalidArgumentException(sprintf('The billSplits property can only contain items of type \StructType\BillSplit, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->billSplits[] = $item;
        return $this;
    }
    /**
     * Get credit value
     * @return bool|null
     */
    public function getCredit()
    {
        return $this->credit;
    }
    /**
     * Set credit value
     * @param bool $credit
     * @return \StructType\Bill
     */
    public function setCredit($credit = null)
    {
        // validation for constraint: boolean
        if (!is_null($credit) && !is_bool($credit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($credit, true), gettype($credit)), __LINE__);
        }
        $this->credit = $credit;
        return $this;
    }
    /**
     * Get dueDate value
     * @return string|null
     */
    public function getDueDate()
    {
        return $this->dueDate;
    }
    /**
     * Set dueDate value
     * @param string $dueDate
     * @return \StructType\Bill
     */
    public function setDueDate($dueDate = null)
    {
        // validation for constraint: string
        if (!is_null($dueDate) && !is_string($dueDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dueDate, true), gettype($dueDate)), __LINE__);
        }
        $this->dueDate = $dueDate;
        return $this;
    }
    /**
     * Get markupAccountId value
     * @return int|null
     */
    public function getMarkupAccountId()
    {
        return $this->markupAccountId;
    }
    /**
     * Set markupAccountId value
     * @param int $markupAccountId
     * @return \StructType\Bill
     */
    public function setMarkupAccountId($markupAccountId = null)
    {
        // validation for constraint: int
        if (!is_null($markupAccountId) && !(is_int($markupAccountId) || ctype_digit($markupAccountId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($markupAccountId, true), gettype($markupAccountId)), __LINE__);
        }
        $this->markupAccountId = $markupAccountId;
        return $this;
    }
    /**
     * Get markupPercentage value
     * @return float|null
     */
    public function getMarkupPercentage()
    {
        return $this->markupPercentage;
    }
    /**
     * Set markupPercentage value
     * @param float $markupPercentage
     * @return \StructType\Bill
     */
    public function setMarkupPercentage($markupPercentage = null)
    {
        // validation for constraint: float
        if (!is_null($markupPercentage) && !(is_float($markupPercentage) || is_numeric($markupPercentage))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($markupPercentage, true), gettype($markupPercentage)), __LINE__);
        }
        $this->markupPercentage = $markupPercentage;
        return $this;
    }
    /**
     * Get ownerDraw value
     * @return bool|null
     */
    public function getOwnerDraw()
    {
        return $this->ownerDraw;
    }
    /**
     * Set ownerDraw value
     * @param bool $ownerDraw
     * @return \StructType\Bill
     */
    public function setOwnerDraw($ownerDraw = null)
    {
        // validation for constraint: boolean
        if (!is_null($ownerDraw) && !is_bool($ownerDraw)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($ownerDraw, true), gettype($ownerDraw)), __LINE__);
        }
        $this->ownerDraw = $ownerDraw;
        return $this;
    }
    /**
     * Get paymentDate value
     * @return string|null
     */
    public function getPaymentDate()
    {
        return $this->paymentDate;
    }
    /**
     * Set paymentDate value
     * @param string $paymentDate
     * @return \StructType\Bill
     */
    public function setPaymentDate($paymentDate = null)
    {
        // validation for constraint: string
        if (!is_null($paymentDate) && !is_string($paymentDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($paymentDate, true), gettype($paymentDate)), __LINE__);
        }
        $this->paymentDate = $paymentDate;
        return $this;
    }
    /**
     * Get refNo value
     * @return string|null
     */
    public function getRefNo()
    {
        return $this->refNo;
    }
    /**
     * Set refNo value
     * @param string $refNo
     * @return \StructType\Bill
     */
    public function setRefNo($refNo = null)
    {
        // validation for constraint: string
        if (!is_null($refNo) && !is_string($refNo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($refNo, true), gettype($refNo)), __LINE__);
        }
        $this->refNo = $refNo;
        return $this;
    }
    /**
     * Get tenantCharges value
     * @return \StructType\VMMLeaseCharge[]|null
     */
    public function getTenantCharges()
    {
        return $this->tenantCharges;
    }
    /**
     * This method is responsible for validating the values passed to the setTenantCharges method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTenantCharges method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTenantChargesForArrayConstraintsFromSetTenantCharges(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $billTenantChargesItem) {
            // validation for constraint: itemType
            if (!$billTenantChargesItem instanceof \StructType\VMMLeaseCharge) {
                $invalidValues[] = is_object($billTenantChargesItem) ? get_class($billTenantChargesItem) : sprintf('%s(%s)', gettype($billTenantChargesItem), var_export($billTenantChargesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The tenantCharges property can only contain items of type \StructType\VMMLeaseCharge, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set tenantCharges value
     * @throws \InvalidArgumentException
     * @param \StructType\VMMLeaseCharge[] $tenantCharges
     * @return \StructType\Bill
     */
    public function setTenantCharges(array $tenantCharges = array())
    {
        // validation for constraint: array
        if ('' !== ($tenantChargesArrayErrorMessage = self::validateTenantChargesForArrayConstraintsFromSetTenantCharges($tenantCharges))) {
            throw new \InvalidArgumentException($tenantChargesArrayErrorMessage, __LINE__);
        }
        $this->tenantCharges = $tenantCharges;
        return $this;
    }
    /**
     * Add item to tenantCharges value
     * @throws \InvalidArgumentException
     * @param \StructType\VMMLeaseCharge $item
     * @return \StructType\Bill
     */
    public function addToTenantCharges(\StructType\VMMLeaseCharge $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VMMLeaseCharge) {
            throw new \InvalidArgumentException(sprintf('The tenantCharges property can only contain items of type \StructType\VMMLeaseCharge, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->tenantCharges[] = $item;
        return $this;
    }
    /**
     * Get terms value
     * @return string|null
     */
    public function getTerms()
    {
        return $this->terms;
    }
    /**
     * Set terms value
     * @param string $terms
     * @return \StructType\Bill
     */
    public function setTerms($terms = null)
    {
        // validation for constraint: string
        if (!is_null($terms) && !is_string($terms)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($terms, true), gettype($terms)), __LINE__);
        }
        $this->terms = $terms;
        return $this;
    }
    /**
     * Get vendor value
     * @return string|null
     */
    public function getVendor()
    {
        return $this->vendor;
    }
    /**
     * Set vendor value
     * @param string $vendor
     * @return \StructType\Bill
     */
    public function setVendor($vendor = null)
    {
        // validation for constraint: string
        if (!is_null($vendor) && !is_string($vendor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vendor, true), gettype($vendor)), __LINE__);
        }
        $this->vendor = $vendor;
        return $this;
    }
    /**
     * Get workOrderID value
     * @return int|null
     */
    public function getWorkOrderID()
    {
        return $this->workOrderID;
    }
    /**
     * Set workOrderID value
     * @param int $workOrderID
     * @return \StructType\Bill
     */
    public function setWorkOrderID($workOrderID = null)
    {
        // validation for constraint: int
        if (!is_null($workOrderID) && !(is_int($workOrderID) || ctype_digit($workOrderID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($workOrderID, true), gettype($workOrderID)), __LINE__);
        }
        $this->workOrderID = $workOrderID;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Bill
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
