<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ClientDataContainer StructType
 * @subpackage Structs
 */
abstract class ClientDataContainer extends AbstractStructBase
{
    /**
     * The clientData
     * Meta information extracted from the WSDL
     * - arrayType: tns1:ClientDataItem[]
     * - base: soapenc:Array
     * - nillable: true
     * - ref: soapenc:arrayType
     * @var \StructType\ClientDataItem[]
     */
    public $clientData;
    /**
     * Constructor method for ClientDataContainer
     * @uses ClientDataContainer::setClientData()
     * @param \StructType\ClientDataItem[] $clientData
     */
    public function __construct(array $clientData = array())
    {
        $this
            ->setClientData($clientData);
    }
    /**
     * Get clientData value
     * @return \StructType\ClientDataItem[]|null
     */
    public function getClientData()
    {
        return $this->clientData;
    }
    /**
     * This method is responsible for validating the values passed to the setClientData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setClientData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateClientDataForArrayConstraintsFromSetClientData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $clientDataContainerClientDataItem) {
            // validation for constraint: itemType
            if (!$clientDataContainerClientDataItem instanceof \StructType\ClientDataItem) {
                $invalidValues[] = is_object($clientDataContainerClientDataItem) ? get_class($clientDataContainerClientDataItem) : sprintf('%s(%s)', gettype($clientDataContainerClientDataItem), var_export($clientDataContainerClientDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The clientData property can only contain items of type \StructType\ClientDataItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set clientData value
     * @throws \InvalidArgumentException
     * @param \StructType\ClientDataItem[] $clientData
     * @return \StructType\ClientDataContainer
     */
    public function setClientData(array $clientData = array())
    {
        // validation for constraint: array
        if ('' !== ($clientDataArrayErrorMessage = self::validateClientDataForArrayConstraintsFromSetClientData($clientData))) {
            throw new \InvalidArgumentException($clientDataArrayErrorMessage, __LINE__);
        }
        $this->clientData = $clientData;
        return $this;
    }
    /**
     * Add item to clientData value
     * @throws \InvalidArgumentException
     * @param \StructType\ClientDataItem $item
     * @return \StructType\ClientDataContainer
     */
    public function addToClientData(\StructType\ClientDataItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClientDataItem) {
            throw new \InvalidArgumentException(sprintf('The clientData property can only contain items of type \StructType\ClientDataItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->clientData[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ClientDataContainer
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
